check := function(group, c, d)
  local r, s;
  r := Representative(c);
  for s in d do
    if (r*s)^2 <> (s*r)^2 then
      return [r,s];
    fi;
  od;
  return fail;
end;
 
LoadPackage("atlasrep");
LoadPackage("io");

LogTo("step9.log");

gr := AtlasGroup("U3(8)");
cc := ConjugacyClasses(gr);
ct := CharacterTable(gr);

bg := BaseOfGroup(gr);
Print("Base of Group: ", bg, "\n");

f := IO_File("step9.rec", "w");
IO_WriteLine(f,"### The format for classinfo is [ r, s, order, comment ]");
IO_WriteLine(f,"data := rec(");
IO_WriteLine(f,"  base := ", bg, ",");
IO_WriteLine(f,"  group := \"U3(8)\",");
IO_WriteLine(f,"  comments := \"For classes with representatives of order 19\",");
IO_WriteLine(f,"  classinfo := [");

Print("For conjugacy classes 19A, 19B of this maximal subgroup\n");
rs := check(gr, cc[ct.19a], cc[ct.19b]);
Print("r:=", OnTuples(bg, rs[1]), ";\n");
Print("s:=", OnTuples(bg, rs[2]), ";\n");
IO_WriteLine(f, "    [ ", OnTuples(bg, rs[1]), ", ", OnTuples(bg, rs[2]), ", 23, \"classes 19a and 19b\" ],");
IO_WriteLine(f, "  ]");
IO_WriteLine(f, ");");
IO_Flush(f);
IO_Close(f);

