LoadPackage("atlasrep");
LoadPackage("io");

name := "J4";

LogTo("step8.log");

gr := Image(IsomorphismPermGroup(Group(AtlasGenerators("J4", 1, 13).generators)));
cc := ConjugacyClasses(gr);
ct := CharacterTable(gr);

bg := BaseOfGroup(gr);
Print("Base of Group: ", bg, "\n");

str := [];
gen := GeneratorsOfGroup(gr);
for t in gen do
  Add(str, t);
od;


f := IO_File("step8.rec", "w");
IO_WriteLine(f,"### The format for classinfo is [ r, s, order, comment ]");
IO_WriteLine(f,"data := rec(");
IO_WriteLine(f,"  base := ", bg, ",");
IO_WriteLine(f,"  group := \"J4M13\",");
IO_WriteLine(f,"  gens := \"", str, "\",");
IO_WriteLine(f,"  comments := \"For the class 4C of J4\",");
IO_WriteLine(f,"  classinfo := [");

4a := cc[ct.4a];
4b := cc[ct.4b];

r := Representative(4a);
for s in 4b do
  if (r*s)^2 <> (s*r)^2 then
    Print("r:=", OnTuples(bg, r), ";\n");
    Print("s:=", OnTuples(bg, s), ";\n");
    IO_WriteLine(f, "    [ ", OnTuples(bg, r), ", ", OnTuples(bg, s), ", 4, \"classes 4a and 4b\" ]");
    break;
  fi;
od;    

IO_WriteLine(f, "  ]");
IO_WriteLine(f, ");");
IO_Flush(f);
IO_Close(f);

