LoadPackage("atlasrep");

fusions := function(ct2, ct1)
  local fus, t;

  fus := FusionConjugacyClasses(ct2, ct1);
  if not fus = fail then
    for t in [1..Size(fus)] do
      Print(ClassNames(ct2)[t], " --> ", ClassNames(ct1)[fus[t]], "\n");
    od;
  else
    for fus in PossibleClassFusions(ct2, ct1) do
      for t in [1..Size(fus)] do
        Print(ClassNames(ct2)[t], " --> ", ClassNames(ct1)[fus[t]], ";\n");
      od;
      Print("--\n");
    od;
  fi;
end;
    
LogTo("step7.log");

Print("Fusion of conjugacy classes: S5xS9 --> Fi24\n");
fusions(CharacterTable("S5xS9"), CharacterTable("Fi24"));

Print("\n==\n");
Print("Fusion of conjugacy classes: Fi24' --> Fi24\n");
fusions(CharacterTable("Fi24'"), CharacterTable("Fi24"));

Print("\n==\n");
Print("Fusion of conjugacy classes: 3.Fi24 --> M\n");
fusions(CharacterTable("3.Fi24"), CharacterTable("M"));


