LogTo("2A.log");;

LoadPackage("atlasrep");;

gr := AtlasGroup("S6(2)");
cc := ConjugacyClasses(gr);;
ct := CharacterTable(gr);;

bg := BaseOfGroup(gr);
Print("Base of Group: ", bg, "\n");

ClassNames(ct);

c := cc[Position(SizesConjugacyClasses(ct), 63)];;             
g := Representative(c);;

Print("Conjugacy class of size: ", Size(c), "\n");
Print("Centralizer of size: ", Size(gr)/Size(c), "\n");


for x in gr do
  if Order(x)=2 then
    h := x*g*Inverse(x);;
    if g*h=h*g and g <> h then
      Print("g:=", OnTuples(bg, g), ";\n");
      Print("h:=", OnTuples(bg, h), ";\n");
      done := true;
      break;
    fi;
  fi;
od;

if done = true then
  
  z := Centralizer(gr, g);
  ctz := CharacterTable(z);
  ccz := ConjugacyClasses(z);
  irr := Irr(ctz);

  ### For real conjugacy classes only
  u := Position(List(ccz, t->g in t), true);
  reps := Filtered(irr, t->t[1]=-t[u]);

  for r in reps do
    e := EigenvaluesChar(r, Position(List(ccz, t->Inverse(x)*g*x in t), true));
    if e[1] in [4..r[1]] or e[1] in [1..(r[1]-4)] then
      Print("Degree: ", r[1], ", infinite-dimensional Nichols algebra\n");
    else
      Print("*** Degree: ", r[1], ", finite-dimensional?\n");
    fi;
  od;
fi;



