LoadPackage("atlasrep");
LoadPackage("io");

check := function(c, d)
  local sg, x, y;
  x := Representative(c);
  for y in d do
    if not (x*y)^2 = (y*x)^2 then
      return [x,y];
    fi;
  od;
  return fail;
end;

name := "step2";

LogTo("step2.log");

gr := AtlasGroup("L5(2)");;
cc := ConjugacyClasses(gr);;
ct := CharacterTable(gr);

bg := BaseOfGroup(gr);
Print("Base of Group: ", bg, "\n");

f := IO_File(Concatenation(name, ".rec"), "w");
IO_WriteLine(f,"### The format for classinfo is [ r, s, order, comment ]");
IO_WriteLine(f,"data := rec(");
IO_WriteLine(f,"  base := ", bg, ",");
IO_WriteLine(f,"  group := \"L5(2)\",");
IO_WriteLine(f,"  comments := \"Th (step 2)\",");
IO_WriteLine(f,"  classinfo := [");


ClassNames(ct);

for i in [ct.31a, ct.31b, ct.31c, ct.31d, ct.31e, ct.31f] do
  for j in [ct.31a, ct.31b, ct.31c, ct.31d, ct.31e, ct.31f] do
    if not i >= j then
      rs := check(cc[i], cc[j]);
      Print("Checking classes ", ClassNames(ct)[i], " and ", ClassNames(ct)[j], "\n");
      if not rs = fail then
	Print("r:=", OnTuples(bg, rs[1]), ";\n");
	Print("s:=", OnTuples(bg, rs[2]), ";\n");
        IO_WriteLine(f, "    [ ", OnTuples(bg, rs[1]), ", ", OnTuples(bg, rs[2]), ", 31, \"Classes ", ClassNames(ct)[i], " and ", ClassNames(ct)[j], "\" ],");
      else
	Print("Fail\n");
      fi;
    fi;
  od;
od;

IO_WriteLine(f, "    [ fail, (), 1, \"one\"]");
IO_WriteLine(f, "  ]");
IO_WriteLine(f, ");");
IO_Flush(f);
IO_Close(f);


